Attribute VB_Name = "modProductsDatabase"

'---------------------------------------------------------------
'     AppForge PDB Converter auto-generated code module
'
'     Source Database: C:\Book\Chap4\Code\Ex1\NWindPalm.mdb
'     Source Table   : Products
'
'     Num Records    : 77
'
'     PDB Table Name : Products
'          CreatorID : OR41
'          TypeID    : DATA
'
'     Converted Time : 9/18/2001 3:28:56 PM
'
'---------------------------------------------------------------

Option Explicit

' Use these constants for the CreatorID and TypeID
Public Const Products_CreatorID As Long = &H4F523431
Public Const Products_TypeID As Long = &H44415441

' Use this global to store the database handle
Public dbProducts As Long

' Use this enumeration to get access to the converted database Fields
Public Enum tProductsDatabaseFields
        ProductId_Field = 0
        ProductName_Field = 1
        SupplierId_Field = 2
        CategoryID_Field = 3
        QuantityPerUnit_Field = 4
        UnitPrice_Field = 5
        UnitsInStock_Field = 6
        UnitsOnOrder_Field = 7
        ReorderLevel_Field = 8
        Discontinued_Field = 9
End Enum

Public Type tProductsRecord
        ProductID As Long       'Number automatically assigned to new product.
        ProductName As String
        SupplierID As Long      'Same entry as in Suppliers table.
        CategoryID As Long      'Same entry as in Categories table.
        QuantityPerUnit As String       '(e.g., 24-count case, 1-liter bottle).
        UnitPrice As Single
        UnitsInStock As Integer
        UnitsOnOrder As Integer
        ReorderLevel As Integer 'Minimum units to maintain in stock.
        Discontinued As Boolean 'Yes means item is no longer available.
End Type


Public Function OpenProductsDatabase() As Boolean

        ' Open the database
        #If APPFORGE Then
        dbProducts = PDBOpen(Byfilename, "Products", 0, 0, 0, 0, afModeReadWrite)
        #Else
        dbProducts = PDBOpen(Byfilename, App.Path & "\Products", 0, 0, 0, 0, afModeReadWrite)
        #End If

        If dbProducts <> 0 Then
                'We successfully opened the database
                OpenProductsDatabase = True

        Else
                'We failed to open the database
                OpenProductsDatabase = False
        End If

End Function


Public Sub CloseProductsDatabase()

        ' Close the database
        PDBClose dbProducts
        dbProducts = 0

End Sub


Public Function ReadProductsRecord(MyRecord As tProductsRecord) As Boolean

        ReadProductsRecord = PDBReadRecord(dbProducts, VarPtr(MyRecord))

End Function


Public Function WriteProductsRecord(MyRecord As tProductsRecord) As Boolean

        WriteProductsRecord = PDBWriteRecord(dbProducts, VarPtr(MyRecord))

End Function
