VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SyncNotify"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Ch6aNotify.cls
' Copyright 2001 Matthew J. Holmes
'
' This module implements the IPDClientNotify COM interface. This interface
' consists of four functions:
'
'   BeginProcess, CfgConduit, ConfigureConduit, GetConduitInfo.
'
' Functions on this interface are invoked by the Palm HotSync manager to
' configure conduits and to synchronize the Palm device.

Option Explicit

' Declare interface
Implements IPDClientNotify

' GetConduitInfo() - called repeatedly by the HotSync manager when it
' is initializing to get conduit name and settings.
Private Function _
IPDClientNotify_GetConduitInfo(ByVal infoType As EGetConduitInfo, _
                               ByVal dwCreatorId As Long, _
                               ByVal dwUserId As Long, _
                               ByVal bstrUserName As String) As Variant
   
    Select Case infoType
    Case eGetConduitName
        IPDClientNotify_GetConduitInfo = "Ch6a Conduit"
    Case eGetConduitVersion
        IPDClientNotify_GetConduitInfo = 3#
    Case eGetDefaultAction
        IPDClientNotify_GetConduitInfo = ESyncTypes.eFast
    Case eGetMfcVersion
        IPDClientNotify_GetConduitInfo = EMfcVersion.ePDMFC_NOT_USED
    End Select

End Function

' CfgConduit() - called by the HotSync manager when the user wants
' to change the conduit's behavior - H/S version 3.0 and greater.
Private Sub IPDClientNotify_CfgConduit(ByVal nCreatorId As Long, _
                                       ByVal nUserId As Long, _
                                       ByVal bstrUserName As String, _
                                       ByVal bstrPathName As String, _
                                       ByVal nSyncPerm As ESyncTypes, _
                                       ByRef nSyncTemp As ESyncTypes, _
                                       ByRef nSyncNew As ESyncTypes, _
                                       ByRef nSyncPref As ESyncPref)

    ' Set up the form: type of sync to perform, user directory
    SyncForm.SetFields nSyncNew
    
    ' Let the user make choices, then retrieve them from the form. The
    ' form must be modal, this is required by COM.
    SyncForm.Show vbModal
    SyncForm.GetFields nSyncNew, nSyncTemp, nSyncPerm, nSyncPref

End Sub

' ConfigureConduit() - called by the HotSync manager when the user wants
' to change the conduit's behavior - H/S versions earlier then 3.0
Private Sub IPDClientNotify_ConfigureConduit(ByVal bstrPathName As String, _
                                             ByVal bstrRegistry As String, _
                                             ByRef nSyncPref As ESyncPref, _
                                             ByRef nSyncType As ESyncTypes)
    
    nSyncType = PDdirectlib.eFast
    nSyncPref = PDdirectlib.ePermanentPreference

End Sub

' BeginProcess() - called by the HotSync manager when it is time
' for this conduit to synchronize.
Private Function IPDClientNotify_BeginProcess() As Boolean
    
    ' Create our sync object and do the work
    Dim Worker As New SyncLogic
    Worker.Synchronize
    
    ' Return false to signal completion!
    IPDClientNotify_BeginProcess = False

End Function
