VERSION 5.00
Begin VB.Form Query 
   Caption         =   "ISP Query Form"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6195
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3195
   ScaleWidth      =   6195
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdPDB 
      Caption         =   "Make PDB"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4920
      TabIndex        =   5
      Top             =   600
      Width           =   1215
   End
   Begin VB.TextBox txtResults 
      Height          =   1815
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   6
      Top             =   1320
      Width           =   6015
   End
   Begin VB.CommandButton cmdQuery 
      Caption         =   "Get Data"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4920
      TabIndex        =   4
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox txtCountry 
      Height          =   315
      Left            =   1680
      TabIndex        =   1
      Top             =   120
      Width           =   2415
   End
   Begin VB.TextBox txtRegion 
      Height          =   315
      Left            =   1680
      TabIndex        =   3
      Top             =   600
      Width           =   2415
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Country:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   180
      Width           =   1335
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Region/State:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   675
      Width           =   1335
   End
End
Attribute VB_Name = "Query"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ISPQuery.frm
' Copyright 2001 - Matthew J. Holmes

Option Explicit

Private ConnObj As ADODB.Connection
Private CmdObj As ADODB.Command
Private RecordObj As ADODB.Recordset

Private Type PhoneRecord
    Region As String
    PhoneNo As String
    Attributes As String
End Type

Private Sub Form_Load()
    Set ConnObj = New ADODB.Connection
    ConnObj.Open "Provider=sqloledb;Data Source=IO;Initial Catalog=ISP;User Id=sa;Password=***;"
End Sub

Private Sub cmdQuery_Click()

    Dim Data As String
    
    RunQuery
    
    If RecordObj.RecordCount > 0 Then
        Do While Not RecordObj.EOF
            Data = Data & Trim(RecordObj("R_Name")) & vbTab _
                        & Trim(RecordObj("N_PhoneNo")) & vbTab _
                        & Trim(RecordObj("N_Attributes")) & vbCrLf
            RecordObj.MoveNext
        Loop
    End If
    
    txtResults.Text = Data
End Sub

Private Sub RunQuery()

    ' Build and run the SQL command
    Set CmdObj = New ADODB.Command
    Set CmdObj.ActiveConnection = ConnObj
    CmdObj.CommandText = MakeSQL
    CmdObj.Execute

    ' Attach a new recordsset to the SQL command and get the data
    Set RecordObj = New ADODB.Recordset
    RecordObj.CursorLocation = adUseClient
    RecordObj.CursorType = adOpenStatic
    RecordObj.Open CmdObj
End Sub

Private Function MakeSQL() As String

    Dim qStr As String
    qStr = "select C.C_Name, R.R_Name, N.N_PhoneNo, N.N_Attributes from tbCountry C, tbRegion R, tbNumber N where N.N_Country = C.C_Key and N.N_Region = R.R_Key"
    
    ' Append the [optional] country
    If txtCountry.Text <> "" Then
        qStr = qStr & " and C.C_Name = '" & Trim(txtCountry.Text) & "'"
    End If
    
    ' Append the [optional] region. Note the LIKE operator and wildcard
    If txtRegion.Text <> "" Then
        qStr = qStr & " and R.R_Name like '" & Trim(txtRegion.Text) & "%'"
    End If
    
    MakeSQL = qStr
End Function

Private Sub cmdPDB_Click()

    Dim db As Long
    Dim rec As PhoneRecord

    If RecordObj.RecordCount = 0 Then Exit Sub
    
    db = CreatePDBFile
    
    RecordObj.MoveFirst
    Do While Not RecordObj.EOF
        
        rec.Region = Trim(RecordObj("R_Name"))
        rec.PhoneNo = Trim(RecordObj("N_PhoneNo"))
        rec.Attributes = Trim(RecordObj("N_Attributes"))
        
        PDBCreateRecordBySchema db
        PDBWriteRecord db, VarPtr(rec)
        PDBUpdateRecord db
        
        RecordObj.MoveNext
    Loop
    
    PDBClose db
End Sub

Private Function CreatePDBFile() As Long

    Dim db As Long
    Dim schema As String

    On Error Resume Next
    Kill App.Path & "\PhoneDB.pdb"

    db = PDBCreateDatabase(App.Path & "\PhoneDB", Id2Long("DATA"), Id2Long("tISP"))
    
    schema = "region string, phoneno string, attributes string"
    PDBCreateTable db, "numbers", schema
    
    CreatePDBFile = db
End Function

Private Function Id2Long(Id As String) As Long

    Dim i As Integer
    Dim value As Long
  
    For i = 1 To Len(Id)
        value = value * 256 + Asc(Mid(Id, i, 1))
    Next i
    
    Id2Long = value
End Function

